﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ScheduleCRUDJS.Models;
using System.Collections;
namespace ScheduleCRUDJS.Controllers
{
    public class HomeController : Controller
    {
        ScheduleDataDataContext db = new ScheduleDataDataContext();
        List<DateTime> dates = new List<DateTime>();
        public ActionResult Index()
        {
            return View();
        }


        public JsonResult GetData()
        {
            IEnumerable data = new ScheduleDataDataContext().MultipleResources.Take(100);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public JsonResult Batch(EditParams param)
        {
            if (param.action == "insert" || (param.action == "batch" && param.added != null)) // this block of code will execute while inserting the appointments
            {
                var value = param.action == "insert" ? param.value : param.added[0];
                int intMax = db.MultipleResources.ToList().Count > 0 ? db.MultipleResources.ToList().Max(p => p.Id) : 1;
                DateTime startTime = Convert.ToDateTime(value.StartTime);
                DateTime startTime1 = Convert.ToDateTime(value.StartTime);
                DateTime endTime = Convert.ToDateTime(value.EndTime);
                if (value.Recurrence!=0) // this code block will execute only for recurrence appointment
                {
                    //Pass the recurrencerule string and the start date of the appointment to this method that will return the dates collection based on the recurrence rule
                    dates = RecurrenceHelper.GetRecurrenceDateTimeCollection(value.RecurrenceRule, Convert.ToDateTime(value.StartTime)).ToList();
                    // Now, the variable “dates” contains the date collection, with which the appointment instances are needed to be created manually.
                    var diff = endTime - startTime1;
                    for (var i = 0; i < dates.Count; i++) // this loop is used to create the appointment instances for the generated dates
                    {
                        startTime = Convert.ToDateTime(dates[i].AddHours(startTime1.Hour).AddMinutes(startTime1.Minute)); //start time for each occurrences will be calculated
                        endTime = Convert.ToDateTime(startTime.AddHours(diff.Hours).AddMinutes(diff.Minutes)); //end time for each occurrences will be calculated

                        MultipleResource appoint = new MultipleResource()// Appointment object creation
                        {
                            Id = value.Id + i,
                            StartTime = startTime,
                            EndTime = endTime,
                            Subject = value.Subject,
                            Recurrence = 0,
                            AllDay = value.AllDay,
                            RecurrenceRule = value.RecurrenceRule
                        };
                        db.MultipleResources.InsertOnSubmit(appoint);
                    }
                }
                else
                {
                MultipleResource appoint = new MultipleResource()
                {
                    Id = intMax + 1,
                    StartTime = startTime,
                    EndTime = endTime,
                    Subject = value.Subject,
                    AllDay = value.AllDay,
                    Recurrence = value.Recurrence,
                    RecurrenceRule = value.RecurrenceRule
                };
                db.MultipleResources.InsertOnSubmit(appoint);
            }
                db.SubmitChanges();
            }

            if (param.action == "remove" || param.deleted != null) // this block of code will execute while removing the appointment
            {
                if (param.action == "remove")
                {
                    int key = Convert.ToInt32(param.key);
                    MultipleResource app = db.MultipleResources.Where(c => c.Id == key).FirstOrDefault();
                    if (app != null) db.MultipleResources.DeleteOnSubmit(app);
                }
                else
                {
                    foreach (var apps in param.deleted)
                    {
                        MultipleResource app = db.MultipleResources.Where(c => c.Id == apps.Id).FirstOrDefault();
                        if (apps != null) db.MultipleResources.DeleteOnSubmit(app);
                    }
                }
                db.SubmitChanges();
            }

            if ((param.action == "batch" && param.changed != null) || param.action == "update")   // this block of code will execute while updating the appointment
            {
                var value = param.action == "update" ? param.value : param.changed[0];
                var filterData = db.MultipleResources.Where(c => c.Id == Convert.ToInt32(value.Id));

                if (filterData.Count() > 0)
                {
                    DateTime startTime = Convert.ToDateTime(value.StartTime);
                    DateTime endTime = Convert.ToDateTime(value.EndTime);
                    MultipleResource appoint = db.MultipleResources.Single(A => A.Id == Convert.ToInt32(value.Id));
                    appoint.StartTime = startTime;
                    appoint.EndTime = endTime;
                    appoint.Subject = value.Subject;
                    appoint.Recurrence = value.Recurrence;
                    appoint.AllDay = value.AllDay;
                    appoint.RecurrenceRule = value.RecurrenceRule;
                }
                db.SubmitChanges();
            }
            IEnumerable data = new ScheduleDataDataContext().MultipleResources.Take(200);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}